#include<bits/stdc++.h>
using namespace std;

const int nmax=1e6+42;
int n,inp[nmax];

int fenwick[nmax];

void init()
{
    for(int i=1;i<=n;i++)fenwick[i]=0;
}
void update(int pos,int val)
{
    while(pos<=n)
    {
        fenwick[pos]+=val;

        pos=pos+(pos&(-pos));
    }
}

int query(int pos)
{
    int ret=0;

    while(pos)
    {
        ret+=fenwick[pos];
        pos=pos-(pos&(-pos));
    }
    return ret;
}
long long inv()
{
    init();

    long long ret=0;

    for(int i=n;i>=1;i--)
    {
        ret+=query(inp[i]);
        update(inp[i],1);
    }

    return ret;
}

int sum(int l,int r)
{
    return query(r)-query(l-1);
}

vector<int> left_up,right_down;

struct rect
{
    int x1,y1,x2,y2;
};

rect info[nmax];

struct upd
{
    int l,r,coeff;
};

vector< upd > updates[nmax];

void note(int x,int y1,int y2,int coeff)
{
    upd cur;
    cur.l=y1;
    cur.r=y2;
    cur.coeff=coeff;

    updates[x].push_back(cur);
}

pair<int/*max*/,int/*lazy*/> tree[4*nmax];

void push(int node)
{
    if(tree[node].second==0)return;

    tree[node*2].second+=tree[node].second;
    tree[node*2+1].second+=tree[node].second;
    tree[node].second=0;
}

pair<int/*max*/,int/*lazy*/> actual(pair<int/*max*/,int/*lazy*/> a)
{
    a.first+=a.second;
    a.second=0;
    return a;
}
pair<int/*max*/,int/*lazy*/> my_merge(pair<int/*max*/,int/*lazy*/> a,pair<int/*max*/,int/*lazy*/> b)
{
    a.first=a.first+a.second;
    a.second=0;

    b.first=b.first+b.second;
    b.second=0;

    return max(a,b);
}
void seg_update(int node,int l,int r,int lq,int rq,int val)
{
    if(l==lq&&r==rq)
    {
        tree[node].second+=val;
        return;
    }

    push(node);

    int av=(l+r)/2;

    if(lq<=av)seg_update(node*2,l,av,lq,min(av,rq),val);
    if(av<rq)seg_update(node*2+1,av+1,r,max(av+1,lq),rq,val);

    tree[node]=my_merge(tree[node*2],tree[node*2+1]);
}

int read()
{
    char c=getchar();

    while(isdigit(c)==0)c=getchar();

    int ret=0;

    while(isdigit(c))
    {
        ret=ret*10+c-'0';
        c=getchar();
    }

    return ret;
}

int main()
{
    n=read();
    for(int i=1;i<=n;i++)inp[i]=read();

    int mx=0;
    for(int i=1;i<=n;i++)
    {
        if(mx<inp[i])
        {
            mx=inp[i];
            left_up.push_back(i);

            info[i].x1=0;
            info[i].x2=-1;
            continue;
        }
        int ok=left_up.size(),not_ok=-1;
        while(ok-not_ok>1)
        {
            int av=(ok+not_ok)/2;

            if(inp[left_up[av]]>inp[i])ok=av;
            else not_ok=av;
        }

        info[i].x2=left_up.size()-1;
        info[i].x1=ok;
    }

    int mn=n+1;
    for(int i=n;i>=1;i--)
    {
        if(mn>inp[i])
        {
            mn=inp[i];
            right_down.push_back(i);

            info[i].y1=0;
            info[i].y2=-1;
            continue;
        }

        int ok=right_down.size(),not_ok=-1;
        while(ok-not_ok>1)
        {
            int av=(ok+not_ok)/2;

            if(inp[right_down[av]]<inp[i])ok=av;
            else not_ok=av;
        }

        info[i].y2=right_down.size()-1;
        info[i].y1=ok;
    }

    long long was=inv();

    //cout<<"was= "<<was<<endl;

    long long outp=was;

    /*
    for(int i=1;i<=n;i++)
        cout<<i<<" -> "<<info[i].x1<<" "<<info[i].y1<<" "<<info[i].x2<<" "<<info[i].y2<<endl;
    */

    for(int i=1;i<=n;i++)
        if(info[i].x1<=info[i].x2&&info[i].y1<=info[i].y2)
        {
            note(info[i].x1,info[i].y1,info[i].y2,1);
            note(info[i].x2+1,info[i].y1,info[i].y2,-1);
        }

    for(int i=0;i<=n;i++)
    {
        for(auto w:updates[i])
            seg_update(1,0,n,w.l,w.r,w.coeff);

        outp=min(outp,was-2*actual(tree[1]).first);
    }

    printf("%lld\n",outp);

    return 0;
}
