#include <bits/stdc++.h>
#pragma GCC optimize("O3")

using namespace std;
typedef long long ll;
template<class T> void check_min(T &a, const T b){ a = (a < b) ? a : b; }
template<class T> void check_max(T &a, const T b){ a = (a > b) ? a : b; }
int get_int();
#define all(x) (x).begin(), (x).end()

const int N = 1e6 + 3;
const int T = 3e7 + 3;

int n, a[N];
ll val[N];
int opt[N];
vector<int> v;
ll ans = 0;

int idx_st[N];

struct Fenwick{
    int a[N];
    Fenwick(){}
    void update(int i, int v){
        for(; i < N; i += i & -i)
            a[i] += v;
    }
    int query(int i){
        int ret = 0;
        for(; i >= 1; i -= i & -i)
            ret += a[i];
        return ret;
    }
} f;

struct Persistent_Segment_Tree{
    int cnt[T], l_ch[T], r_ch[T], sz;
    void add_node(){
        cnt[sz] = 0;
        l_ch[sz] = r_ch[sz] = -1;
        ++sz;
    }
    Persistent_Segment_Tree(){
        sz = 0;
        add_node();
    }
    int update(int i, int idx, int l = 1, int r = n){
        if(idx < l || r < idx) return i;
        if(l == r){
            add_node();
            cnt[sz - 1] = 1;
            return sz - 1;
        }
        if(l_ch[i] == -1){
            add_node();
            add_node();
            l_ch[i] = sz - 2;
            r_ch[i] = sz - 1;
        }
        int mid = (l + r) >> 1;
        int new_l = update(l_ch[i], idx, l, mid);
        int new_r = update(r_ch[i], idx, mid + 1, r);
        add_node();
        cnt[sz - 1] = cnt[new_l] + cnt[new_r];
        l_ch[sz - 1] = new_l;
        r_ch[sz - 1] = new_r;
        return sz - 1;
    }
    int query(int i, int sl, int sr, int l = 1, int r = n){
        if(sr < l || r < sl) return 0;
        if(sl <= l && r <= sr) return cnt[i];
        if(!cnt[i]) return 0;
        int mid = (l + r) >> 1;
        return query(l_ch[i], sl, sr, l, mid) + query(r_ch[i], sl, sr, mid + 1, r);
    }
    int safe_query(int i, int sl, int sr){
        if(sl > sr) return 0;
        return query(i, sl, sr);
    }
} st;

void dnc(int l, int r, int sl, int sr){
    if(l > r) return;

    int mid = (l + r) >> 1;
    int idx = v[mid];
    opt[mid] = -1;
    val[mid] = 1;
    for(int i = max(idx + 1, sl); i <= sr; ++i){
        if(a[i] > a[idx]) continue;
        ll curr = 0;
        curr -= 2 * (st.safe_query(idx_st[i - 1], a[i] + 1, a[idx] - 1) - st.safe_query(idx_st[idx - 1], a[i] + 1, a[idx] - 1));
        if(curr <= val[mid]){
            val[mid] = curr;
            opt[mid] = i;
        }
    }
    check_min(ans, val[mid]);

    dnc(l, mid - 1, sl, opt[mid]);
    dnc(mid + 1, r, opt[mid], sr);
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    n = get_int();
    for(int i = 1; i <= n; ++i)
        a[i] = get_int();

    bool ok = true;
    for(int i = 1; i <= n; ++i)
        if(a[i] != i)
            ok = false;

    if(ok){
        cout << "0\n";
        return 0;
    }

    ll inv = 0;
    for(int i = 1; i <= n; ++i){
        inv += i - 1 - f.query(a[i]);
        f.update(a[i], 1);
    }

    int mn = n;
    for(int i = n; i >= 1; --i){
        if(a[i] > mn){
            while(!v.empty() && a[v.back()] < a[i])
                v.pop_back();
            v.push_back(i);
        }
        else mn = a[i];
    }
    reverse(v.begin(), v.end());

    idx_st[0] = 0;
    for(int i = 1; i <= n; ++i)
        idx_st[i] = st.update(idx_st[i - 1], a[i]);

    dnc(0, (int)v.size() - 1, 1, n);

    cout << ans + inv << "\n";
}

int ptr = N - 1;
char buff[N];

void next_char(){ if(++ptr == N - 1) fread(buff, 1, N, stdin), ptr = 0; }

int get_int(){
    int x;
    cin >> x;
    return x;
    int ret = 0;
    for(; buff[ptr] < '0' || '9' < buff[ptr]; next_char());
    for(; '0' <= buff[ptr] && buff[ptr] <= '9'; next_char())
        ret = 10 * ret + buff[ptr] - '0';
    return ret;
}

