#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 1e4 + 3;

int n;
int a[maxn];
void read()
{
    cin >> n;
    for (int i = 1; i <= n; i++)
        cin >> a[i];
}

int tr[maxn];
void update(int pos, int val)
{
    for (; pos <= n; pos += pos & -pos)
        tr[pos] += val;
}

int get_prefix(int pos)
{
    int ans = 0;
    for (; pos >= 1; pos -= pos & -pos)
        ans += tr[pos];

    return ans;
}

long long count_inversions()
{
    for (int i = 1; i <= n; i++)
        tr[i] = 0;

    long long ans = 0;
    for (int i = n; i >= 1; i--)
    {
        ans += get_prefix(a[i]);
        update(a[i], 1);
    }

    return ans;
}

int segtr[maxn * 4];
void merge(int v)
{
    segtr[v] = max(segtr[v * 2], segtr[v * 2 + 1]);
}

void update_tr(int v, int l, int r, int pos, int val)
{
    if (l == r)
    {
        segtr[v] = val;
        return;
    }

    int mid = (l + r) / 2;
    if (pos <= mid)
        update_tr(v * 2, l, mid, pos, val);

    else
        update_tr(v * 2 + 1, mid + 1, r, pos, val);

    merge(v);
}

int get_tr(int v, int l, int r, int ll, int rr)
{
    if (l > rr || r < ll)
        return 0;

    if (l >= ll && r <= rr)
        return segtr[v];

    int mid = (l + r) / 2;
    return max(get_tr(v * 2, l, mid, ll, rr), get_tr(v * 2 + 1, mid + 1, r, ll, rr));
}

int f(int l, int r)
{
    int ans = 0;
    for (int i = l; i <= r; i++)
        if (a[i] <= a[l] && a[i] >= a[r])
            ans++;
    return ans;
}

void solve()
{
    int ans = count_inversions();
    vector <int> pr, su;
    pr.push_back(1);
    for (int i = 2; i <= n; i++)
        if (a[i] > a[pr.back()])
            pr.push_back(i);

    su.push_back(n);
    for (int i = n-1; i >= 1; i--)
        if (a[i] < a[su.back()])
            su.push_back(i);

    int maxf = 0;
    for (auto i: pr)
        for (auto j: su)
        {
            if (j < i)
                break;

            maxf = max(maxf, f(i, j));
        }

    cout << min(ans, ans + 4 - 2 * maxf) << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
