#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 3e5 + 3;

int n;
int a[maxn];
void read()
{
    cin >> n;
    for (int i = 1; i <= n; i++)
        cin >> a[i];
}

int bit[maxn];
void update(int pos, int val)
{
    for (; pos <= n; pos += pos & -pos)
        bit[pos] += val;
}

int get_prefix(int pos)
{
    int ans = 0;
    for (; pos >= 1; pos -= pos & -pos)
        ans += bit[pos];

    return ans;
}

long long count_inversions()
{
    long long ans = 0;
    for (int i = n; i >= 1; i--)
    {
        ans += get_prefix(a[i]);
        update(a[i], 1);
    }

    return ans;
}

struct node
{
    int val, l, r;
    node() {val = 0, l = r = -1;}
};

int idx = 0;
node tr[maxn * 30];

int build(int v, int l, int r)
{
    if (l == r)
    {
        tr[idx++] = node();
        return idx-1;
    }

    int mid = (l + r) / 2;
    int curr_idx = idx++;
    tr[curr_idx] = node();
    tr[curr_idx].l = build(v * 2, l, mid);
    tr[curr_idx].r = build(v * 2 + 1, mid + 1, r);

    return curr_idx;
}

int update(int v, int l, int r, int pos)
{
    if (l == r)
    {
        tr[idx++] = node();
        tr[idx-1].val = 1;

        return idx-1;
    }

    int curr_idx = idx++;
    int mid = (l + r) / 2;

    if (pos <= mid)
    {
        tr[curr_idx].r = tr[v].r;
        tr[curr_idx].l = update(tr[v].l, l, mid, pos);
    }

    else
    {
        tr[curr_idx].l = tr[v].l;
        tr[curr_idx].r = update(tr[v].r, mid + 1, r, pos);
    }

    tr[curr_idx].val = tr[tr[curr_idx].l].val + tr[tr[curr_idx].r].val;
    return curr_idx;
}

int get(int v, int l, int r, int ll, int rr)
{
    if (l > rr || r < ll)
        return 0;

    if (l >= ll && r <= rr)
        return tr[v].val;

    int mid = (l + r) / 2;
    return get(tr[v].l, l, mid, ll, rr) + get(tr[v].r, mid + 1, r, ll, rr);
}

vector <int> pr, su;
int root[maxn];

int f(int l, int r)
{
    if (a[l] < a[r])
    return 0;

    return get(root[r], 1, n, a[r], a[l]) - get(root[l-1], 1, n, a[r], a[l]);
}

void solve()
{
    long long ans = count_inversions();

    pr.push_back(1);
    for (int i = 2; i <= n; i++)
        if (a[i] > a[pr.back()])
            pr.push_back(i);

    su.push_back(n);
    for (int i = n-1; i >= 1; i--)
        if (a[i] < a[su.back()])
            su.push_back(i);

    // reverse(su.begin(), su.end());

    root[0] = build(1, 1, n);
    for (int i = 1; i <= n; i++)
        root[i] = update(root[i-1], 1, n, a[i]);

    int maxf = 0;
    for (auto i: pr)
        for (auto j: su)
    {
        if (j < i)
            break;

        maxf = max(maxf, f(i, j));
    }

    cout << min(ans, ans + 4ll - 2ll * maxf) << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
