#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 1e6 + 3;

int n;
int a[maxn];
void read()
{
    cin >> n;
    for (int i = 1; i <= n; i++)
        cin >> a[i];
}

int bit[maxn];
void update(int pos, int val)
{
    for (; pos <= n; pos += pos & -pos)
        bit[pos] += val;
}

int get_prefix(int pos)
{
    int ans = 0;
    for (; pos >= 1; pos -= pos & -pos)
        ans += bit[pos];

    return ans;
}

long long count_inversions()
{
    long long ans = 0;
    for (int i = n; i >= 1; i--)
    {
        ans += get_prefix(a[i]);
        update(a[i], 1);
    }

    return ans;
}

vector <int> pr, su;
int f(int l, int r)
{
    if (a[l] < a[r])
    return 0;

    return get_prefix(a[l]) - get_prefix(a[r]-1);
}

int maxf;
int last_l, last_r;

void adjust(int l, int r)
{
    while (last_r < r)
    {
        last_r++;
        update(a[last_r], 1);
    }

    while (l < last_l)
    {
        last_l--;
        update(a[last_l], 1);
    }

    while (r < last_r)
    {
        update(a[last_r], -1);
        last_r--;
    }

    while (l > last_l)
    {
        update(a[last_l], -1);
        last_l++;
    }
}

void rec(int l, int r, int opt_l, int opt_r)
{
    if (l > r)
        return;

    int mid = (l + r) / 2, opt_mid = -1, curr_max = -1;
    for (int i = opt_l; i <= opt_r; i++)
        if (pr[mid] <= su[i])
    {
        adjust(pr[mid], su[i]);
        int temp = f(pr[mid], su[i]);
        if (temp >= curr_max)
            curr_max = temp, opt_mid = i;
    }

    maxf = max(maxf, curr_max);
    if (l == r)
        return;

    rec(l, mid-1, opt_l, opt_mid);
    rec(mid+1, r, opt_mid, opt_r);
}

void solve()
{
    long long ans = count_inversions();

    pr.push_back(1);
    for (int i = 2; i <= n; i++)
        if (a[i] > a[pr.back()])
            pr.push_back(i);

    su.push_back(n);
    for (int i = n-1; i >= 1; i--)
        if (a[i] < a[su.back()])
            su.push_back(i);

    reverse(su.begin(), su.end());

    for (int i = 1; i <= n; i++)
        bit[i] = 0;

        last_l = last_r = 1;
        update(a[1], 1);

    rec(0, (int)pr.size()-1, 0, (int)su.size()-1);
    cout << min(ans, ans + 4ll - 2ll * maxf) << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
