#include <iostream>
#include <deque>

using namespace std;

const int MAXN = 2e6 + 5;
const int inf = 1e9 + 5;

int n;
int a[MAXN];

int chain[MAXN];
void solveTestcase()
{
    int K;
    int rw, rg;

    cin >> n >> K;
    cin >> rw >> rg;
    for(int i = 0;i<n;i++) cin >> a[i];
    if(rw<rg) swap(rw, rg);

    chain[0] = 0;
    for(int i = 1;i<n;i++)
    {
        if(a[i]-a[i-1]>=rg) chain[i] = chain[i-1];
        else chain[i] = i;
    }

    for(int i = 0;i<n-1;i++)
    {
        if(a[i+1]-a[i]<rg)
        {
            cout << "0" << '\n';
            return;
        }
    }
    for(int i = 0;i<n-2;i++)
    {
        if(a[i+2]-a[i]<rg)
        {
            cout << "0" << '\n';
            return;
        }
    }

    if(chain[n-1]==0)
    {
        cout << "1" << '\n';
        return;
    }

    deque <int> dq;
    dq.push_back(0);

    for(int i = 1;i<n;i++)
    {
        while(dq.empty()==false && dq.front()<chain[i-1]-1) dq.pop_front();

        if(dq.empty()==false && a[i]-a[dq.front()]>=rw) dq.push_back(i);
        else if(chain[i-1]==0) dq.push_back(i);
    }

    if(dq.empty()==false && dq.back()>=chain[n-1]-1)
    {
        cout << "1" << '\n';
        return;
    }
    if(dq.empty()==false && dq.back()==n-1)
    {
        cout << "1" << '\n';
        return;
    }
    cout << "0" << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int T;
    cin >> T;

    while(T--) solveTestcase();
}
