#include <iostream>
#include <cstring>
#include <vector>
#include <deque>
#include <bitset>

using namespace std;

const int MAXN = 1500 + 5;
const int inf = 1e9 + 5;

struct State
{
    int pos[3];
    int lastPut;

    State()
    {
        memset(this->pos, 0, sizeof(this->pos));
    }

    State clone()
    {
        State res = State();
        res.pos[0] = pos[0];
        res.pos[1] = pos[1];
        res.pos[2] = pos[2];
        res.lastPut = lastPut;

        return res;
    }

    int getMax()
    {
        return max(max(pos[0], pos[1]), pos[2]);
    }
};

int n;
int a[MAXN];

deque <State> states[2];
bitset <MAXN> isAdded[MAXN][MAXN];

/*
void resetSlice(bool slice)
{
    for(int i = 0;i<=n;i++)
    {
        for(int j = 0;j<=n;j++)
        {
            for(int lastPut = 0;lastPut<3;lastPut++)
            {
                dp[i][j][lastPut][slice] = false;
            }
        }
    }
}
*/

bool checkAdded(State &s)
{
    return isAdded[s.pos[0]][s.pos[1]][s.pos[2]];
}

void add(State &s, bool slice)
{
    isAdded[s.pos[0]][s.pos[1]][s.pos[2]] = true;
    states[slice].push_back(s);
}

void solveTestcase()
{
    int K;
    int rw, rg;

    cin >> n >> K;

    vector <int> r;
    for(int i = 0;i<K;i++)
    {
        int x;
        cin >> x;
        r.push_back(x);
    }

    a[0] = -inf;
    for(int i = 1;i<=n;i++) cin >> a[i];

    for(int i = 0;i<=n;i++)
        for(int j = 0;j<=n;j++)
            isAdded[i][j].reset();

    states[0].clear();
    states[1].clear();
    states[0].push_back(State());

    for(int i = 1;i<=n;i++)
    {
        states[i&1].clear();
        for(int curr = 0;curr<3;curr++)
        {
            for(State &s: states[(i&1)^1])
            {
                if(a[i]-a[s.pos[curr]]>=r[curr])
                {
                    State newS = s.clone();
                    newS.pos[curr] = i;

                    if(checkAdded(newS)==false)
                    {
                        add(newS, (i&1));
                        if(i==n)
                        {
                            cout << "1" << '\n';
                            return;
                        }
                    }
                }
            }
        }
    }

    cout << "0" << '\n';
    return;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int T;
    cin >> T;

    while(T--) solveTestcase();
}
/*
1
3 2
1000 2
1 2 100
*/
