#include <algorithm>
#include <iostream>
#include <cstring>
#include <vector>

using namespace std;

struct Limit
{
    bool type;
    int i, j, k;

    Limit(){}
    Limit(bool type, int i, int j, int k)
    {
        this->type = type;
        this->i = i;
        this->j = j;
        this->k = k;
    }
};

int n, B;
int c[22];
vector <Limit> allLimits;

long long cNum = 0;

void handleInput()
{
    int m;
    cin >> n >> m >> B;

    for(int i = 0;i<n;i++)
        cin >> c[i];
    reverse(c, c+n);

    for(int iter = 0;iter<m;iter++)
    {
        char c;
        int i, j, k;

        cin >> i >> c >> j >> k;
        allLimits.push_back(Limit((c=='+'), i, j, k));
    }
}

void loadDigs(vector <int> &digs, long long x)
{
    while(x!=0)
    {
        digs.push_back(x%10);
        x /= 10;
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    handleInput();

    for(int i = n-1;i>=0;i--)
        cNum = cNum*B + c[i];

    int ans = 0;
    for(long long a = 0;a<=cNum;a++)
    {
        vector <int> aDigs, bDigs;
        long long b = cNum - a;

        loadDigs(aDigs, a);
        loadDigs(bDigs, b);
        if(aDigs.size()!=n || bDigs.size()!=n) continue;

        bool fail = false;
        for(Limit l: allLimits)
        {
            int val;
            if(l.type==false) val = aDigs[l.i] - bDigs[l.j];
            else val = aDigs[l.i] + bDigs[l.j];

            if(val!=l.k)
            {
                fail = true;
                break;
            }
        }

        if(fail==false)
        {
            ans++;
            cout << a << " " << b << '\n';
        }
    }

    cout << ans << '\n';
}
