#include <algorithm>
#include <iostream>
#include <cstring>
#include <vector>

using namespace std;

const int inf = 1e9 + 5;
const long long mod = 1e9 + 7;

struct Limit
{
    bool type;
    int i, j, k;

    Limit(){}
    Limit(bool type, int i, int j, int k)
    {
        this->type = type;
        this->i = i;
        this->j = j;
        this->k = k;
    }
};

int n, B;
int c[22];
vector <Limit> allLimits;

int aVal[22], bVal[22];
bool seenA[22], seenB[22];

void handleInput()
{
    int m;
    cin >> n >> m >> B;

    for(int i = 0;i<n;i++)
        cin >> c[i];
    reverse(c, c+n);

    for(int iter = 0;iter<m;iter++)
    {
        char c;
        int i, j, k;

        cin >> i >> c >> j >> k;
        allLimits.push_back(Limit((c=='+'), i, j, k));
    }

    for(int i = 0;i<n;i++)
    {
        allLimits.push_back(Limit(true, i, i, B-1));
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    handleInput();

    long long answer = 1;
    for(int i = n-1;i>=0;i--)
    {
        if(seenA[i]==false)
        {
            //new component
            //cout << " ---> " << i << '\n';

            seenA[i] = true;
            while(true)
            {
                bool update = false;
                for(Limit l: allLimits)
                {
                    if(seenA[l.i]==true && seenB[l.j]==false)
                    {
                        seenB[l.j] = true;
                        update = true;
                    }
                    if(seenA[l.i]==false && seenB[l.j]==true)
                    {
                        seenA[l.i] = true;
                        update = true;
                    }
                }

                if(update==false) break;
            }

            long long cnt = 0;
            for(int val = ((i==n-1)?1:0);val<B-((i==n-1)?1:0);val++)
            {
                for(int j = 0;j<n;j++)
                    aVal[j] = bVal[j] = inf;

                aVal[i] = val;
                while(true)
                {
                    bool update = false;
                    for(Limit l: allLimits)
                    {
                        if(aVal[l.i]!=inf && bVal[l.j]==inf)
                        {
                            update = true;

                            if(l.type==false) bVal[l.j] = aVal[l.i] - l.k;
                            else bVal[l.j] = l.k - aVal[l.i];
                        }
                        if(bVal[l.j]!=inf && aVal[l.i]==inf)
                        {
                            update = true;

                            if(l.type==false) aVal[l.i] = l.k + bVal[l.j];
                            else aVal[l.i] = l.k - bVal[l.j];
                        }
                    }

                    if(update==false) break;
                }


                bool fail = false;
                for(Limit l: allLimits)
                {
                    if(aVal[l.i]==inf || bVal[l.j]==inf) continue;

                    int val;
                    if(l.type==false) val = aVal[l.i] - bVal[l.j];
                    else val = aVal[l.i] + bVal[l.j];

                    if(val!=l.k)
                    {
                        fail = true;
                        break;
                    }
                }

                for(int j = 0;j<n;j++)
                {
                    if(aVal[j]==inf) continue;
                    if(aVal[j]<0 || aVal[j]>=B)
                    {
                        fail = true;
                        break;
                    }
                    if(bVal[j]<0 || bVal[j]>=B)
                    {
                        fail = true;
                        break;
                    }
                }

                if(aVal[n-1]==0 || bVal[n-1]==0) fail = true;

                /*
                cout << "val: " << val << '\n';
                for(int i = 0;i<n;i++) cout << aVal[i] << " ";
                cout << '\n';
                for(int i = 0;i<n;i++) cout << bVal[i] << " ";
                cout << '\n';
                cout << "fail? " << fail << '\n';
                */

                if(fail==false) cnt++;
            }

            answer = (answer*cnt)%mod;
        }
    }

    cout << answer << '\n';
}
/*
5 3 10
9 9 9 9 9
2 + 4 6
1 - 2 3
4 + 3 7
*/
