#include <algorithm>
#include <iostream>
#include <cstring>
#include <vector>

using namespace std;

const int inf = 1e9 + 5;
const long long mod = 1e9 + 7;

struct Limit
{
    bool type;
    int i, j, k;

    Limit(){}
    Limit(bool type, int i, int j, int k)
    {
        this->type = type;
        this->i = i;
        this->j = j;
        this->k = k;
    }
};

int n, B;
int c[22];
vector <Limit> allLimits;
vector <Limit> colLimits[22];

int aVal[22], bVal[22];
bool seenA[22], seenB[22];

long long memo[22][2];
long long rec(int digInd, int carry)
{
    if(digInd==n)
    {
        return (carry==0);
    }

    if(memo[digInd][carry]!=-1)
        return memo[digInd][carry];

    long long ans = 0;
    for(int digSum: {c[digInd]-carry, c[digInd]+B-carry})
    {
        for(int a = 0;a<B;a++)
        {
            int b = digSum - a;

            if(b<0 || b>=B) continue;
            if(digInd==n-1 && a==0) continue;
            if(digInd==n-1 && b==0) continue;

            bool fail = false;
            for(Limit l: colLimits[digInd])
            {
                int val;
                if(l.type==false) val = a - b;
                else val = a + b;

                if(val!=l.k)
                {
                    fail = true;
                    break;
                }
            }
            if(fail==true) continue;

            aVal[digInd] = a;
            bVal[digInd] = b;
            ans = (ans + rec(digInd+1, digSum/B))%mod;
        }
    }

    memo[digInd][carry] = ans;
    return ans;
}

void handleInput()
{
    int m;
    cin >> n >> m >> B;

    for(int i = 0;i<n;i++)
        cin >> c[i];
    reverse(c, c+n);

    for(int iter = 0;iter<m;iter++)
    {
        char c;
        int i, j, k;

        cin >> i >> c >> j >> k;

        colLimits[i].push_back(Limit((c=='+'), i, j, k));
        allLimits.push_back(Limit((c=='+'), i, j, k));
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    handleInput();

    memset(memo, -1, sizeof(memo));
    cout << rec(0, 0) << '\n';
}
/*
5 1 10
9 9 9 9 9
2 - 2 3
*/
