#include <iostream>
#include <vector>
using namespace std;

const int MAXN = 1000006;
const int INF = 1 << 30;

int n, a[MAXN];
int inv_cnt = 0;
vector<int> tree[(1 << 21) + 121];

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
    }
}

void build(int v = 1, int l = 1, int r = n)
{
    if (l == r)
    {
        tree[v].push_back(a[l]);
        return;
    }

    tree[v].reserve(r - l + 1);

    int mid = (l + r) / 2;
    build(v << 1 | 0, l, mid + 0);
    build(v << 1 | 1, mid + 1, r);

    int lp = 0, rp = 0;
    while (true)
    {
        int lv = (lp < (int)tree[v << 1 | 0].size()) ? tree[v << 1 | 0][lp] : INF;
        int rv = (rp < (int)tree[v << 1 | 1].size()) ? tree[v << 1 | 1][rp] : INF;

        if (lv == INF and rv == INF) break;
        if (lv < rv) tree[v].push_back(tree[v << 1 | 0][lp++]);
        if (lv > rv)
        {
            inv_cnt += tree[v << 1 | 0].size() - lp;
            tree[v].push_back(tree[v << 1 | 1][rp++]);
        }
    }
}

int le, ri, x;
int query(int v = 1, int l = 1, int r = n)
{
    if (l > ri or le > r or le > ri) return 0;
    if (le <= l and r <= ri)
    {
        int lit = 0, rit = tree[v].size() - 1, res;
        if (tree[v].front() > x) return 0;

        while (lit <= rit)
        {
            int mid = (lit + rit) >> 1;
            if (tree[v][mid] <= x) // never equal
            {
                res = mid;
                lit = mid + 1;
            }
            else rit = mid - 1;
        }

        return res + 1;
    }

    int mid = (l + r) >> 1;
    return query(v << 1 | 0, l, mid + 0) + query(v << 1 | 1, mid + 1, r);
}

int QUERY(int LE, int RI, int X)
{
    /*le = LE;
    ri = RI;
    x = X;
    return query();*/

    int cnt = 0;
    for (int i = le; i <= ri; ++ i)
    {
        if (a[i] < x) cnt++;
    }
    return cnt;
}

int main()
{
    Init();
    build();

    int opt = 0;
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = i + 1; j <= n; ++ j)
        {
            if (a[i] > a[j])
            {
                int lft = 2 * QUERY(i + 1, j - 1, a[i]) - j + i + 1;
                int rgh = j - i - 1 - 2 * QUERY(i + 1, j - 1, a[j]);
                if (opt < lft + rgh + 1)
                {
                    opt = lft + rgh + 1;
                }
            }
        }
    }

    cout << min(inv_cnt, inv_cnt - opt + 1) << endl;
    return 0;
}
